Version française
Home     About     Download     Resources     Contact us    
Browse thread
[Caml-list] PostgreSQL-OCaml 1.0.1
[ Home ] [ Index: by date | by threads ]
[ Search: ]

[ Message by date: previous | next ] [ Message in thread: previous | next ] [ Thread: previous | next ]
Date: -- (:)
From: Markus Mottl <markus@o...>
Subject: Re: [Caml-list] PostgreSQL-OCaml 1.0.1
On Thu, 29 Jan 2004, Alain.Frisch@ens.fr wrote:
> Ahem. The last release is dated 2004-01-20 ;-)  (added support for
> escaping strings).

Uh, oh, this must have been some kind of quantum entanglement making us
start adding changes the same day ;-)

> The library is used by a non-negligible number of people, including
> by some companies and for other libraries (e.g. mod_caml, Chartpak,
> DBForge, ...). And according to some mails I got, the users are quite
> satisfied with the current library. Moreover, it has been packaged
> for some Linux distributions.

Yes, your library was a very good starting point. I think the new version
is slightly cleaner and more regular though. I have just released a new
version (1.2.2) that makes some incompatible changes for better support
of default arguments, because, as it seems, you want to maintain the
initial interface, anyway. Thus, there is not so much need for me to
keep things as compatible as possible.

> It's a good thing to add documentation (even though the users
> would need to read the libpq doc anyway).

True, but having some short docs in the interface saves time in many
cases.

> Actually, this is the only feature request for Postgres that I have
> not honoured. But changing the interface (changing names, types,
> and removing all the non-OO low-level interface) would force existing
> users to rewrite there code for no benefit (AFAICT).

Understandable.

> So I'm not going to stop maintaining the existing library, even though
> I'd be glad to give maintenance to you since I'm not using the library,
> and even though I feel it's somewhat a waste of resources for the
> community to maintain and package two libraries.

How about making my recent release the new major version? Most libraries
have to introduce incompatibilities at some point of time when they
evolve anyway. I still remember changing the interface of Pcre to make
use of default arguments, a totally incompatible move. Users dropped
the old version instantly without complaining.

> I would have appreciated to know about your intention to "fork" the
> library before the public annoucement so that we could have agreed on
> a policy. Well anyway, not a big deal.

Sorry about that! I actually hadn't even intended to rewrite it, this,
ahem, just happened! I wanted to use your library for storing online
business transactions and therefore took a very close look at all of
the code. Since I'm a pedant by nature, I started rewriting some bits
here and there and suddenly it came to me that I could as well make a
new release :-)

Next time I'll contact original authors a bit earlier. It was really a
stupid coincidence that we started out adding changes more or less the
same day after several years.

On Thu, 29 Jan 2004, Richard Jones wrote:
> From my point of view (mod_caml depends on the postgres support) it
> would be nice to have just one library to work with.  Perhaps combine
> the best features of both into a single release?

Even though the interfaces are not fully type compatible, it is very
easy to adapt existing code. The OCaml-compiler + supported editors
will allow you to jump from effected line to line very quickly,
and changes usually require hardly any effort. The two versions are
otherwise feature-compatible and also pretty feature-complete wrt. what
PostgreSQL offers.

Best regards,
Markus

-- 
Markus Mottl          http://www.oefai.at/~markus          markus@oefai.at

-------------------
To unsubscribe, mail caml-list-request@inria.fr Archives: http://caml.inria.fr
Bug reports: http://caml.inria.fr/bin/caml-bugs FAQ: http://caml.inria.fr/FAQ/
Beginner's list: http://groups.yahoo.com/group/ocaml_beginners